!uno off;TITLE UNO
;AUTHOR entropy
;COMMANDS uno(0)
;VERSION: 1.8
;HELP uno [On/Off/Top10/Place]|Toggles UNO On/Off, or sets the various settings.|none

;============================== ALIASES

alias -l highscore {
  var %old, %k = $2, %points = $4
  if (!$exists($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.uno.scores.txt"))) { write -c $+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.uno.scores.txt") }
  if ($read($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.uno.scores.txt"),nw,$3 *)) { %old = $readn | inc %points $gettok($ifmatch,2,32) | write $+(-dl,$readn) $+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.uno.scores.txt") }
  var %a = 1, %b, %c = n
  while ($read($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.uno.scores.txt"),n,%a) && %c == n) {
    %b = $read($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.uno.scores.txt"),n,%a)
    if (%points > $gettok(%b,2,32)) { %c = y | if (%a < %old) { hadd $1 $+(%k,.moveup) %a } | else { hdel $1 $+(%k,.moveup) } | write $+(-il,%a) $+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.uno.scores.txt") $3 %points }
    inc %a
  }
  if (%c == n) { write $+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.uno.scores.txt") $3 %points }
}
alias -l top10 {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  var %a = 1, %b, %c
  while ($read($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.uno.scores.txt"),%a) && %a <= 10) {
    %c = $read($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.uno.scores.txt"),%a)
    %b = $addtok(%b,$+($chr(40),$ord($readn),$chr(41),$chr(32),$gettok(%c,1,32),$chr(32),[,$bytes($gettok(%c,2,32),b),]),32)
    inc %a
  }
  if (%b) { sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ *** $2 UNO top10 players *** $chr(3) | sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ %b $chr(3) }
  else { sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ There are no UNO scores recorded. $chr(3) }
}
alias -l getcard {
  :start
  var %a = $replace($r(0,14),10,S,11,R,12,DT,14,WD4,13,W), %s = $replace($r(1,4),1,B,2,G,3,Y,4,R)
  var %card = $iif(W* !iswm %a,$+(%a,%s),%a)
  if (!$hget($1,$+($2,.cards))) {
    var %a = 1, %b = $hget($1,$+($2,.hands)), %c, %total = W W W W 0G 1G 2G 3G 4G 5G 6G 7G 8G 9G 1G 2G 3G 4G 5G 6G 7G 8G 9G DTG DTG SG SG RG RG 0R 1R 2R 3R 4R 5R 6R 7R 8R 9R 1R 2R 3R 4R 5R 6R 7R 8R 9R DTR DTR SR SR RR RR 0Y 1Y 2Y 3Y 4Y 5Y 6Y 7Y 8Y 9Y 1Y 2Y 3Y 4Y 5Y 6Y 7Y 8Y 9Y DTY DTY SY SY RY RY 0B 1B 2B 3B 4B 5B 6B 7B 8B 9B 1B 2B 3B 4B 5B 6B 7B 8B 9B DTB DTB SB SB RB RB WD4 WD4 WD4 WD4
    while ($gettok(%b,%a,32)) {
      %c = $ifmatch
      %total = $remtok(%total,%c,1,32)
      inc %a
    }
    hadd $1 $+($2,.cards) %total
  }
  if (!$istok($hget($1,$+($2,.cards)),%card,32) || $findtok($hget($1,$+($2,.hands)),%card,0,32) >= 2 && %card != W && %card != WD4 || $findtok($hget($1,$+($2,.hands)),%card,0,32) >= 4 && %card == W || $findtok($hget($1,$+($2,.hands)),%card,0,32) >= 4 && %card == WD4) { goto start }
  hadd $1 $+($2,.cards) $remtok($hget($1,$+($2,.cards)),%card,1,32)
  hadd $1 $+($2,.hands) $hget($1,$+($2,.hands)) %card
  return %card
}
alias -l roundplayers {
  var %p = $hget(cgsb,$+($1,.prefix)), %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ UNO has now started... $chr(3)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Type $+(,%p,UNO) join to join. $chr(3)
  .timeruno -o 1 45 startuno $1-
}
alias -l startuno {
  hadd $1 $+($2,.cards) W W W W 0G 1G 2G 3G 4G 5G 6G 7G 8G 9G 1G 2G 3G 4G 5G 6G 7G 8G 9G DTG DTG SG SG RG RG 0R 1R 2R 3R 4R 5R 6R 7R 8R 9R 1R 2R 3R 4R 5R 6R 7R 8R 9R DTR DTR SR SR RR RR 0Y 1Y 2Y 3Y 4Y 5Y 6Y 7Y 8Y 9Y 1Y 2Y 3Y 4Y 5Y 6Y 7Y 8Y 9Y DTY DTY SY SY RY RY 0B 1B 2B 3B 4B 5B 6B 7B 8B 9B 1B 2B 3B 4B 5B 6B 7B 8B 9B DTB DTB SB SB RB RB WD4 WD4 WD4 WD4
  hadd $1 $+($2,.direction) Right
  hadd $1 $+($2,.turn) $gettok($hget($1,$+($2,.uno.players)),1,32)
  hadd $1 $+($2,.pos) 1
  hadd $1 $+($2,.start) $ctime
  :start
  var %a = $getcard($1,$2)
  hadd $1 $+($2,.card) %a
  var %c = $hget($1,$+($2,.card))
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  if ($remove($hget($1,$+($2,.card)),B,R,Y,G) !isnum 0-9) { hadd $1 $+($2,.cards) $hget($1,$+($2,.cards)) %a | goto start }
  elseif ($numtok($hget($1,$+($2,.uno.players)),32) <= 1) { sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ UNO stopped. Not enough players. $chr(3) | enduno $1-2 }
  elseif ($numtok($hget($1,$+($2,.uno.players)),32) > 10) { sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ UNO stopped. Too many players. $chr(3) | enduno $1-2 }
  else { 
    var %a = 1, %b, %c
    %c = $hget($1,$+($2,.card))
    var %color
    if (W* iswm %c) { %color = $+($chr(3),00,$chr(44),01) }
    elseif (*R iswm %c) { %color = $+($chr(3),01,$chr(44),04) }
    elseif (*B iswm %c) { %color = $+($chr(3),00,$chr(44),12) }
    elseif (*G iswm %c) { %color = $+($chr(3),01,$chr(44),09) }
    elseif (*Y iswm %c) { %color = $+($chr(3),01,$chr(44),08) }
    sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ It is now $+(,$hget($1,$+($2,.turn)),'s) turn. Playing on: $+(,%color,[,%c,],)

    var %a = 1
    while ($gettok($hget($1,$+($2,.uno.players)),%a,32)) {
      %b = $ifmatch
      %c = $getcard($1,$2) $getcard($1,$2) $getcard($1,$2) $getcard($1,$2) $getcard($1,$2) $getcard($1,$2) $getcard($1,$2) $getcard($1,$2)
      hinc $1 $+(%b,.to.dealt) 7
      hadd $1 $+($2,.,%b,.hand) %c
      hdel $1 $+(%b,.dr)
      hdel $1 $+(%b,.pa)
      hdel $1 $+(%b,.pl)
      hdel $1 $+(%b,.dealt)
      hdel $1 $+(%b,.skip)
      hinc $1 $+(%b,.dealt) 7
      inc %a
    }
    %b = $hget($1,$+($2,.turn))

    var %n = 1, %z = $hget($1,$+($2,.,%b,.hand)), %c, %total, %color
    while ($gettok(%z,%n,32)) {
      %c = $ifmatch
      if (W* iswm %c) { %color = $+($chr(3),00,$chr(44),01) }
      elseif (*R iswm %c) { %color = $+($chr(3),01,$chr(44),04) }
      elseif (*B iswm %c) { %color = $+($chr(3),00,$chr(44),12) }
      elseif (*G iswm %c) { %color = $+($chr(3),01,$chr(44),09) }
      elseif (*Y iswm %c) { %color = $+($chr(3),01,$chr(44),08) }
      %c = $+(%color,[,%c,],$chr(3))
      %total = %total %c
      inc %n
    }
    sockwrite -n $1 notice %b $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,%total,) - You have 30s to play. $chr(3)
    .timeruno. $+ $2 -o 1 30 timernext $1 $2 $hget($1,$+($2,.turn))
  }
}
alias -l endinguno {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ The hand is now over! $chr(3)
  var %a = 1, %b = $hget($1,$+($2,.uno.players)), %c, %h, %high, %o, %topcard, %total = 0
  while ($gettok(%b,%a,32)) {
    %c = $ifmatch
    %h = $hget($1,$+($2,.,%c,.hand))
    if (%h) { callhand $1 $2 %c %h }
    inc %total $gettotal(%h)
    inc %a
  }

  var %dr = $hget($1,$+($3,.dr))
  if (!%dr) { %dr = 0 }
  var %pa = $hget($1,$+($3,.pa))
  if (!%pa) { %pa = 0 }
  var %pl = $hget($1,$+($3,.pl))
  if (!%pl) { %pl = 0 }
  var %de = $hget($1,$+($3,.dealt))
  if (!%de) { %de = 0 }
  var %sk = $hget($1,$+($3,.skip))
  if (!%sk) { %sk = 0 }
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$3,) is the winner with $+(,$bytes(%total,b), $iif(%total == 1,point!,points!)) - Draws:[ $+ %dr $+ ] Passes:[ $+ %pa $+ ] Plays:[ $+ %pl $+ ] Dealt:[ $+ %de $+ ] Skipped:[ $+ %sk $+ ] $chr(3)
  highscore $1 $2 $3 %total
  var %to = $gettok($read($+(",$scriptdir,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.uno.scores.txt"),w,$3 *),2,32)
  sockwrite -n $1 notice $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You have $+(,$bytes(%to,b), $iif(%to == 1,point,points)) and are in $+(,$ord($readn),) place! $chr(3)
  enduno $1-3
}
alias -l callhand { 
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  var %a = 1, %b = $4-, %c, %total, %color
  while ($gettok(%b,%a,32)) {
    %c = $ifmatch
    if (W* iswm %c) { %color = $+($chr(3),00,$chr(44),01) }
    elseif (*R iswm %c) { %color = $+($chr(3),01,$chr(44),04) }
    elseif (*B iswm %c) { %color = $+($chr(3),00,$chr(44),12) }
    elseif (*G iswm %c) { %color = $+($chr(3),01,$chr(44),09) }
    elseif (*Y iswm %c) { %color = $+($chr(3),01,$chr(44),08) }
    %c = $+(%color,[,%c,],$chr(3)))
    %total = %total %c
    inc %a
  }
  var %dr = $hget($1,$+($3,.dr))
  if (!%dr) { %dr = 0 }
  var %pa = $hget($1,$+($3,.pa))
  if (!%pa) { %pa = 0 }
  var %pl = $hget($1,$+($3,.pl))
  if (!%pl) { %pl = 0 }
  var %de = $hget($1,$+($3,.dealt))
  if (!%de) { %de = 0 }
  var %sk = $hget($1,$+($3,.skip))
  if (!%sk) { %sk = 0 }
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$3,) had $+(,%total,) - Draws:[ $+ %dr $+ ] Passes:[ $+ %pa $+ ] Plays:[ $+ %pl $+ ] Dealt:[ $+ %de $+ ] Skipped:[ $+ %sk $+ ] $chr(3)
}
alias -l enduno {
  .timeruno off
  hadd $1 $+($2,.uno.status) Off
  hdel $1 $+($2,.direction)
  hdel $1 $+($2,.uno.players)
  hdel $1 $+($2,.start)
  hdel $1 $+($2,.card)
  hdel $1 $+($2,.pos)
  hdel $1 $+($2,.turn)
  hdel $1 $+($2,.color)
  var %a = 1, %b = $hget($1,$+($2,.uno.players)), %c
  while ($gettok(%b,%a,32)) {
    %c = $ifmatch
    hdel $1 $+($2,.,%c,.draw)
    inc %a
  }
  var %b = 1, %c
  while ($hfind($1,*.hands,1,w).item) {
    hdel $1 $ifmatch
    inc %b
  }
  $+(.timeruno.,$2,*) off
  $+(.timer,$1,.,$hget(cgsb,$+($1,.network)),.,$2,.top10.uno) off
}
alias -l reverse {
  var %angle = $hget($1,$+($2,.direction))
  hadd $1 $+($2,.direction) $iif($hget($1,$+($2,.direction)) == Left,Right,Left)
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Direction changes from $+(,%angle,) to $+(,$hget($1,$+($2,.direction)),) $+ ... $chr(3)
}
alias -l callturn {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  var %c = $hget($1,$+($2,.card)), %color, %player
  if (W* iswm %c || %c == W) { %color = $+($chr(3),00,$chr(44),01) }
  elseif (*R iswm %c || %c == R) { %color = $+($chr(3),01,$chr(44),04) }
  elseif (*B iswm %c || %c == B) { %color = $+($chr(3),00,$chr(44),12) }
  elseif (*G iswm %c || %c == G) { %color = $+($chr(3),01,$chr(44),09) }
  elseif (*Y iswm %c || %c == Y) { %color = $+($chr(3),01,$chr(44),08) }
  %player = $gettok($hget($1,$+($2,.uno.players)),$hget($1,$+($2,.pos)),32)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ It is now $+(,%player,'s) turn. Playing on: $+(,%color,[,$iif($len(%c) == 1,W,$upper(%c)),],) $chr(3)
  var %a = 1, %b = $hget($1,$+($2,.,%player,.hand)), %c, %total, %color
  while ($gettok(%b,%a,32)) {
    %c = $ifmatch
    if (W* iswm %c) { %color = $+($chr(3),00,$chr(44),01) }
    elseif (*R iswm %c) { %color = $+($chr(3),01,$chr(44),04) }
    elseif (*B iswm %c) { %color = $+($chr(3),00,$chr(44),12) }
    elseif (*G iswm %c) { %color = $+($chr(3),01,$chr(44),09) }
    elseif (*Y iswm %c) { %color = $+($chr(3),01,$chr(44),08) }
    %c = $+(%color,[,%c,],$chr(3)))
    %total = %total %c
    inc %a
  }
  sockwrite -n $1 notice %player $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$upper(%total),) - You have 30s to play. $chr(3)
  .timeruno. $+ $2 -o 1 30 timernext $1 $2 %player
}
alias -l timernext {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  hinc $1 $+($2,.,$3,.timeout)

  if ($hget($1,$+($2,.,$3,.timeout)) >= 5) {
    hdel $1 $+($2,.,$3,.draw)
    hadd $1 $+($2,.uno.players) $remtok( $hget($1,$+($2,.uno.players)),$3 ,1,32)
    hdel $1 $+($2,.,$3,.hand)
    sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$3,) has been kicked from the game for not participating in 5 turns. $chr(3)
    if ($numtok($hget($1,$+($2,.uno.players)),32) <= 1) {
      enduno $1 $2 $3
      var %b = 1, %c
      while ($hfind($1,*.hands,1,w).item) { hdel $1 $ifmatch | inc %b }
      sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,UNO,) has been disabled! Not enough active players left to play! $chr(3)
      return
    }
  }
  else { sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$3,) has been skipped for not playing fast enough... $+($chr(40),$hget($1,$+($2,.,$3,.timeout)),$chr(41)) $chr(3) }
  forcenext $1 $2
  callturn $1 $2
}
alias -l drawfour {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  var %preplayer = $gettok($hget($1,$+($2,.uno.players)),$hget($1,$+($2,.pos)),32)
  var %c = $getcard($1,$2) $getcard($1,$2) $getcard($1,$2) $getcard($1,$2)
  var %to = $iif($3,$3,%preplayer)
  hadd $1 $+($2,.hands) $hget($1,$+($2,.hands)) %c
  hadd $1 $+($2,.,%to,.hand) $hget($1,$+($2,.,%to,.hand)) %c
  var %a = 1, %b = $hget($1,$+($2,.,%to,.hand)), %c, %total, %color
  while ($gettok(%b,%a,32)) {
    %c = $ifmatch
    if (W* iswm %c) { %color = $+($chr(3),00,$chr(44),01) }
    elseif (*R iswm %c) { %color = $+($chr(3),01,$chr(44),04) }
    elseif (*B iswm %c) { %color = $+($chr(3),00,$chr(44),12) }
    elseif (*G iswm %c) { %color = $+($chr(3),01,$chr(44),09) }
    elseif (*Y iswm %c) { %color = $+($chr(3),01,$chr(44),08) }
    %c = $+(%color,[,%c,],$chr(3)))
    %total = %total %c
    inc %a
  }
  hinc $1 $+(%to,.dealt) 4
  hinc $1 $+(%to,.to.dealt) 4
  hinc $1 $+(%to,.skip)
  hinc $1 $+(%to,.to.skip)
  if (!$3) { sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,%to,) is dealt 4 Cards and skipped... $chr(3) }
}
alias -l drawtwo {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  var %preplayer = $gettok($hget($1,$+($2,.uno.players)),$hget($1,$+($2,.pos)),32)
  var %c = $getcard($1,$2) $getcard($1,$2)
  var %to = $iif($3,$3,%preplayer)
  hadd $1 $+($2,.hands) $hget($1,$+($2,.hands)) %c
  hadd $1 $+($2,.,%to,.hand) $hget($1,$+($2,.,%to,.hand)) %c
  var %a = 1, %b = $hget($1,$+($2,.,%to,.hand)), %c, %total, %color
  while ($gettok(%b,%a,32)) {
    %c = $ifmatch
    if (W* iswm %c) { %color = $+($chr(3),00,$chr(44),01) }
    elseif (*R iswm %c) { %color = $+($chr(3),01,$chr(44),04) }
    elseif (*B iswm %c) { %color = $+($chr(3),00,$chr(44),12) }
    elseif (*G iswm %c) { %color = $+($chr(3),01,$chr(44),09) }
    elseif (*Y iswm %c) { %color = $+($chr(3),01,$chr(44),08) }
    %c = $+(%color,[,%c,],$chr(3)))
    %total = %total %c
    inc %a
  }
  hinc $1 $+(%to,.dealt) 2
  hinc $1 $+(%to,.to.dealt) 2
  hinc $1 $+(%to,.skip)
  hinc $1 $+(%to,.to.skip)
  if (!$3) { sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,%to,) is dealt 2 Cards and skipped... $chr(3) }
}
alias -l skipped {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  var %preplayer = $gettok($hget($1,$+($2,.uno.players)),$hget($1,$+($2,.pos)),32)
  sockwrite -n $1 privmsg $2 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,%preplayer,) is skipped... $chr(3)
  hinc $1 $+(%preplayer,.skip)
  hinc $1 $+(%preplayer,.to.skip)
}
alias -l forcenext {
  var %a = $hget($1,$+($2,.pos))
  if ($hget($1,$+($2,.direction)) == Left) { dec %a | if (%a < 1) { %a = $numtok($hget($1,$+($2,.uno.players)),32) } }
  else { inc %a | if (%a > $numtok($hget($1,$+($2,.uno.players)),32)) { %a = 1 } }
  hadd $1 $+($2,.pos) %a
  hadd $1 $+($2,.turn) $gettok($hget($1,$+($2,.uno.players)),$hget($1,$+($2,.pos)),32)
}
alias -l gettotal {
  var %a = 1, %b = $1-, %total = 0, %c
  while ($gettok(%b,%a,32)) {
    %c = $ifmatch
    if (DT* iswm %c || S* iswm %c || R* iswm %c) { inc %total 20 }
    elseif (W* iswm %c) { inc %total 50 }
    else { inc %total $left(%c,1) }
    inc %a
  }
  return %total
}
alias -l hand {
  var %t = $gettok($hget(cgsb,$+($1,.colors)),1,32), %u = $gettok($hget(cgsb,$+($1,.colors)),2,32)
  var %a = 1, %b = $hget($1,$+($2,.,$3,.hand)), %c, %total, %color
  while ($gettok(%b,%a,32)) {
    %c = $ifmatch
    if (W* iswm %c) { %color = $+($chr(3),00,$chr(44),01) }
    elseif (*R iswm %c) { %color = $+($chr(3),01,$chr(44),04) }
    elseif (*B iswm %c) { %color = $+($chr(3),00,$chr(44),12) }
    elseif (*G iswm %c) { %color = $+($chr(3),01,$chr(44),09) }
    elseif (*Y iswm %c) { %color = $+($chr(3),01,$chr(44),08) }
    %c = $+(%color,[,%c,],$chr(3)))
    %total = %total %c
    inc %a
  }
  if (%total) { sockwrite -n $1 notice $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,%total,) $chr(3) }
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:uno:{
  var %c = $hget(cgsb,buffer)
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %p = $hget(cgsb,$+($cgsbsock,.prefix))
  tokenize 32 %c
  if ($2 == privmsg) {
    if (($+($hget(cgsb,$+($cgsbsock,.prefix)),uno) != $mid($4,2,$len($4)) && !$istok(dr pa ca st pl or co,$mid($4,2,$len($4)),32) && !$istok(draw pass cards stats play order count,$mid($4,2,$len($4)),32))) { return }
    elseif ((:dr == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On) || (:draw == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On)) {
      if (!$istok($hget($cgsbsock,$+($3,.uno.players)),$gettok($mid($1,2,$len($1)),1,33),32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You are not playing! $chr(3) }
      elseif ($hget($cgsbsock,$+($3,.turn)) != $gettok($mid($1,2,$len($1)),1,33)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ It is not your turn! $chr(3) }
      elseif ($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.draw))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You already drew! $chr(3) }
      else {
        var %a = $getcard($cgsbsock,$3)
        hadd $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.draw) $ctime
        hadd $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand) $hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand)) %a
        var %a = 1, %b = $hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand)), %c, %total, %color
        while ($gettok(%b,%a,32)) {
          %c = $ifmatch
          if (W* iswm %c) { %color = $+($chr(3),00,$chr(44),01) }
          elseif (*R iswm %c) { %color = $+($chr(3),01,$chr(44),04) }
          elseif (*B iswm %c) { %color = $+($chr(3),00,$chr(44),12) }
          elseif (*G iswm %c) { %color = $+($chr(3),01,$chr(44),09) }
          elseif (*Y iswm %c) { %color = $+($chr(3),01,$chr(44),08) }
          %c = $+(%color,[,%c,],$chr(3)))
          %total = %total %c
          inc %a
        }
        hinc $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.dr)
        hinc $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.to.dr)
        hinc $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.dealt)
        hinc $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.to.dealt)
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,%total,) $chr(3)
      }
    }
    elseif ((:pa == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On) || (:pass == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On)) {
      if (!$istok($hget($cgsbsock,$+($3,.uno.players)),$gettok($mid($1,2,$len($1)),1,33),32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You are not playing! $chr(3) }
      elseif ($hget($cgsbsock,$+($3,.turn)) != $gettok($mid($1,2,$len($1)),1,33)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ It is not your turn! $chr(3) }
      elseif (!$hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.draw))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You must draw before you can pass! $chr(3) }
      else {
        .timeruno. $+ $3 off
        hdel $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.draw)
        hinc $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.pa)
        hinc $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.to.pa)
        forcenext $cgsbsock $3
        callturn $cgsbsock $3
      }
    }
    elseif ((:ca == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On) || (:cards == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On)) {
      hand $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33)
    }
    elseif ((:co == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On) || (:count == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On)) {
      var %a = 1, %b = $hget($cgsbsock,$+($3,.uno.players)), %c, %total
      while ($gettok(%b,%a,32)) { %c = $ifmatch | %total = %total $+($chr(40),%a,$chr(41),$chr(32),%c,$chr(32),$chr(91),$numtok($hget($cgsbsock,$+($3,.,%c,.hand)),32),$chr(93)) | inc %a }
      sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Count: %total $chr(3)
    }
    elseif ((:or == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On) || (:order == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On)) {
      var %a = 1, %b, %c
      while ($gettok($hget($cgsbsock,$+($3,.uno.players)),%a,32)) { %c = $ifmatch | %b = %b $+($chr(40),%a,$chr(41)) $iif($hget($cgsbsock,$+($3,.turn)) == %c,$+(,%c,),%c) | inc %a }
      sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Order: %b Direction: $iif($hget($cgsbsock,$+($3,.direction)),$ifmatch,Right) $chr(3)
    }
    elseif ((:st == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On) || (:stats == $strip($4-) && $hget($cgsbsock,$+($3,.uno.status)) == On)) {
      var %dr = $hget($cgsbsock,$+($gettok($mid($1,2,$len($1)),1,33),.to.dr))
      if (!%dr) { %dr = 0 }
      var %pa = $hget($cgsbsock,$+($gettok($mid($1,2,$len($1)),1,33),.to.pa))
      if (!%pa) { %pa = 0 }
      var %pl = $hget($cgsbsock,$+($gettok($mid($1,2,$len($1)),1,33),.to.pl))
      if (!%pl) { %pl = 0 }
      var %dealt = $hget($cgsbsock,$+($gettok($mid($1,2,$len($1)),1,33),.to.dealt))
      if (!%dealt) { %dealt = 0 }
      var %vo = $hget($cgsbsock,$+($gettok($mid($1,2,$len($1)),1,33),.to.skip))
      if (!%vo) { %vo = 0 }
      sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Draws:[ $+ %dr $+ ] Plays:[ $+ %pl $+ ] Passes:[ $+ %pa $+ ] Dealt:[ $+ %dealt $+ ] Skipped:[ $+ %vo $+ ] $chr(3)
    }
    elseif ((:pl == $strip($4) && $hget($cgsbsock,$+($3,.uno.status)) == On) || (:play == $strip($4) && $hget($cgsbsock,$+($3,.uno.status)) == On)) {
      if (!$istok($hget($cgsbsock,$+($3,.uno.players)),$gettok($mid($1,2,$len($1)),1,33),32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You are not playing! $chr(3) }
      elseif ($hget($cgsbsock,$+($3,.turn)) != $gettok($mid($1,2,$len($1)),1,33)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ It is not your turn! $chr(3) }
      elseif (!$istok($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand)),$5,32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not have that card! $chr(3) }
      elseif (($5 == W && !$6) || ($5 == WD4 && !$6) || ($5 == W && !$istok(B G Y R,$6,32)) || ($5 == WD4 && !$istok(B G Y R,$6,32))) {
        sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid card! $chr(3)
      }
      else {
        var %card = $hget($cgsbsock,$+($3,.card))
        if (($len($5) == 1 && $5 != W) || (!%card && $hget($cgsbsock,$+($3,.color)) != $right($5,1)) || (!$istok(B G R Y W 4,$right($5,1),32)) || ($right(%card,1) != $right($5,1) && $left(%card,1) != $left($5,1) && %card && $5 != WD4 && $5 != W)) {
          sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid card! $chr(3)
        }
        else {
          .timeruno. $+ $3 off
          hadd $cgsbsock $+($3,.card) $iif($5 == W || $5 == WD4,$6,$5)
          var %a = $hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand))
          hadd $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand) $remtok(%a,$5,1,32)
          hadd $cgsbsock $+($3,.hands) $remtok($hget($cgsbsock,$+($3,.hands)),$5,1,32)
          if (!$hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand))) {
            var %pos = $hget($cgsbsock,$+($3,.pos))
            inc %pos
            if (!$gettok($hget($cgsbsock,$+($3,.uno.players)),%pos,32)) { %pos = 1 }
            var %player = $gettok($hget($cgsbsock,$+($3,.uno.players)),%pos,32)
            if (WD4 == $5) { drawfour $cgsbsock $3 %player }
            elseif (DT* iswm $5) { drawtwo $cgsbsock $3 %player }
            endinguno $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33)
            return
          }
          elseif ($numtok($hget($cgsbsock,$+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand)),32) == 1) { sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$gettok($mid($1,2,$len($1)),1,33),) declares UNO! $chr(3) }
          if (WD4 == $5) { hadd $cgsbsock $+($3,.color) $6 | forcenext $cgsbsock $3 | drawfour $cgsbsock $3 | forcenext $cgsbsock $3 }
          elseif (W == $5) { hadd $cgsbsock $+($3,.color) $6 | forcenext $cgsbsock $3 }
          elseif (DT* iswm $5) { forcenext $cgsbsock $3 | drawtwo $cgsbsock $3 | forcenext $cgsbsock $3 }
          elseif (S* iswm $5) { forcenext $cgsbsock $3 | skipped $cgsbsock $3 | forcenext $cgsbsock $3 }
          elseif (R* iswm $5) { forcenext $cgsbsock $3 | reverse $cgsbsock $3 | forcenext $cgsbsock $3 }
          else { forcenext $cgsbsock $3 }
          callturn $cgsbsock $3
          hinc $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.pl)
          hinc $cgsbsock $+($gettok($mid($1,2,$len($1)),1,33),.to.pl)
          hdel $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.draw)
          hdel $cgsbsock $+($3,.,color)
        }
      }
    }
    elseif ($+(:,$hget(cgsb,$+($cgsbsock,.prefix)),*) iswm $strip($4)) {
      var %a = $hget($cgsbsock,access)
      if ($+(:,%p,uno) == $strip($4)) {
        if (top10 == $5) {
          top10 $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33)
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($5 == On || $5 == Off) {
          if (%a < $getcom(uno)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) | return }
          elseif ($hget($cgsbsock,$+($3,.uno.status)) == $5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ UNO is already $5 $+ . $chr(3) }
          else { 
            hadd $cgsbsock $+($3,.uno.status) $5
            sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ UNO is now: $+(,$5,.)
            if ($5 == On) {
              roundplayers $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33)
              $+(.timer,$cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.top10.uno) -o 0 300 top10 $cgsbsock $3
              sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$gettok($mid($1,2,$len($1)),1,33),) has entered the game. (1) $chr(3)
              hadd $cgsbsock $+($3,.uno.players) $addtok( $hget($cgsbsock,$+($3,.uno.players)),$gettok($mid($1,2,$len($1)),1,33) ,32)
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ UNO Commands: dr (draw), pl (play), pa (pass), co (count), or (order), ca (cards) st (stats), Get ready for UNO! 
              hdel $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.timeout)
            }
            else {
              enduno $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33)
              $+(.timer,$cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.top10.uno) off
              hdel $cgsbsock $+($3,.start)
              var %b = 1, %c
              while ($hfind($cgsbsock,*.hands,1,w).item) {
                hdel $cgsbsock $ifmatch
                inc %b
              }
            }
          }
        }
        elseif (place == $5) {
          var %g = $read($+(",$scriptdir,$cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.uno.scores.txt"),nw,$gettok($mid($1,2,$len($1)),1,33) *)
          if (%g) { sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+($chr(40),$ord($readn),$chr(41)) $gettok($mid($1,2,$len($1)),1,33) $+([,$bytes($gettok(%g,2,32),b),]) }
          else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You don't have a score recorded. $chr(3) }
        }
        elseif ($5 == join) {
          if ($hget($cgsbsock,$+($3,.uno.status)) != On) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ UNO is not on! $chr(3) }
          elseif ($istok($hget($cgsbsock,$+($3,.uno.players)),$gettok($mid($1,2,$len($1)),1,33),32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You have already joined the game! $chr(3) }
          elseif ($numtok($hget($cgsbsock,$+($3,.uno.players)),32) == 10) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Sorry, all slots are full for this game. $chr(3) }
          else {
            hdel $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.draw)
            hdel $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.timeout)
            hadd $cgsbsock $+($3,.uno.players) $addtok( $hget($cgsbsock,$+($3,.uno.players)),$gettok($mid($1,2,$len($1)),1,33) ,32)
            sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ UNO Commands: dr (draw), pl (play), pa (pass), co (count), or (order), ca (cards), st (stats), Get ready for UNO!
            sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$gettok($mid($1,2,$len($1)),1,33),) has entered the game. $+($chr(40),$numtok($hget($cgsbsock,$+($3,.uno.players)),32),$chr(41)) $chr(3)
            if ($hget($cgsbsock,$+($3,.start))) {
              var %c = $getcard($cgsbsock,$3) $getcard($cgsbsock,$3) $getcard($cgsbsock,$3) $getcard($cgsbsock,$3) $getcard($cgsbsock,$3) $getcard($cgsbsock,$3) $getcard($cgsbsock,$3) $getcard($cgsbsock,$3)
              hadd $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand) %c
            }
          }
        }
        elseif ($5 == quit) {
          if ($hget($cgsbsock,$+($3,.uno.status)) != On) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ UNO is not on! $chr(3) }
          elseif (!$istok($hget($cgsbsock,$+($3,.uno.players)),$gettok($mid($1,2,$len($1)),1,33),32)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You are not in the game! $chr(3) }
          elseif ($hget($cgsbsock,$+($3,.uno.players)) == 2) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You cannot quit when there is only 2 players playing! $chr(3) }
          else {
            hdel $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.draw)
            hadd $cgsbsock $+($3,.uno.players) $remtok( $hget($cgsbsock,$+($3,.uno.players)),$gettok($mid($1,2,$len($1)),1,33) ,1,32)
            hdel $cgsbsock $+($3,.,$gettok($mid($1,2,$len($1)),1,33),.hand)
            sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$gettok($mid($1,2,$len($1)),1,33),) has quit UNO! $chr(3)
            if ($numtok($hget($cgsbsock,$+($3,.uno.players)),32) <= 1) {
              enduno $cgsbsock $3 $gettok($mid($1,2,$len($1)),1,33)
              $+(.timer,$cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.top10.uno) off
              hdel $cgsbsock $+($3,.start)
              var %b = 1, %c
              while ($hfind($cgsbsock,*.hands,1,w).item) { hdel $cgsbsock $ifmatch | inc %b }
              sockwrite -n $cgsbsock privmsg $3 $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,UNO,) has been disabled! Not enough active players left to play! $chr(3)
              .timeruno. $+ $3 off
            }
            elseif ($hget($cgsbsock,$+($3,.turn)) == $gettok($mid($1,2,$len($1)),1,33)) { 
              .timeruno. $+ $3 off
              forcenext $cgsbsock $3
              callturn $cgsbsock $3
            }
          }
        }
      }
    }
  }
}
