;TITLE ACCESS
;AUTHOR entropy
;COMMANDS add(2) del(2) list(1) wipe(2) kick(2) kickban(2) op(2) voice(1) topic(2) mode(2) exempt(2) unexempt(2) invite(2) uninvite(2) ban(2) unban(2) addchanops(3) deopvoice(2)
;VERSION: 1.7
;HELP add [1-4/black] [nick/host]|Adds nick/host to access list.|aop
;HELP del [1-4/black] [nick/host]|Deletes nick/host from access list.|aop
;HELP list [1-4/black]|Lists specified access levels on #channel.|avoice
;HELP wipe [1-4/black]|Wipes specified access level.|aop
;HELP kick [nick1,nick2,nick3]|Kicks specified nicks from #channel.|aop
;HELP kickban [nick1,nick2,nick3]|Kicks & bans specified nicks from #channel.|aop
;HELP op [nick1,nick2,nick3]|Ops specified nicks on #channel.|aop
;HELP voice [nick1,nick2,nick3]|Voices specified nicks on #channel.|avoice
;HELP topic [topic]|Sets the channel topic.|aop
;HELP mode [+modes/-modes]|Sets the channel modes.|aop
;HELP exempt [host]|Adds host to channel exempt list.|aop
;HELP unexempt [host]|Removes host from channel exempt list.|aop
;HELP invite [host]|Adds host to channel invite list.|aop
;HELP uninvite [host]|Removes host from channel invite list.|aop
;HELP ban [host]|Adds host to channel ban list.|aop
;HELP unban [host]|Removes host from channel ban list.|aop
;HELP addchanops [1-4]|Adds all chanops as level specified on channel.|sop
;HELP deopvoice [nick]|Deops then voices [nick].|aop
;HELP opvoice [nick]|Ops/Voices [nick].|aop

;============================== ALIASES
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
alias -l countmodes {
  var %a = 1, %b, %f
  while ($mid($1,%a,1)) {
    %b = $ifmatch
    if (%b !isin +-) { inc %f }
    inc %a
  }
  return %f
}
alias -l ismode {
  ;$1=sockname,$2=mode,$3=channel
  if ($2 isin $hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$3,.nicks),$hget(cgsb,$+($1,.nick)))) { return $true }
}
alias -l isothermode {
  ;$1=sockname,$2=mode,$3=channel,$4=nick
  if ($2 isin $hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$3,.nicks),$4)) { return $true }
}
alias -l appendmode {
  var %a = 1, %b, %n, %f, %y = $4-, %m, %nicks
  while ($mid($3,%a,1)) {
    %b = $ifmatch
    %n = $+(%n,%b)
    if (%b !isin +-) { inc %f | %nicks = $addtok(%nicks,$gettok(%y,%f,32),32) }
    else { %m = %b }
    if ($countmodes(%n) == $hget(cgsb,$hget($1,modes)) || %f == $numtok(%y,32) || %n == $3) { sockwrite -n $1 mode $2 $iif($left(%n,1) !isin +-,$+(%m,%n),%n) %nicks | %nicks = "" | %n = "" }
    inc %a
  }
}
alias -l checkstatus {
  var %a = $hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$2,.nicks),$3) 
  if (@ !isin %a && $4 == @) { sockwrite -n $1 mode $2 +o $3 }
  elseif (@ !isin %a && + !isin %a && $4 == +) { sockwrite -n $1 mode $2 +v $3 }
}
alias -l isadmin {
  var %b
  if ($hfind($1,$+($2,.admin),1,w).item) {
    %b = $remove($hfind($1,$+($2,.admin),1,w).item,.admin)
    if ($2 iswm %b || %b iswm $2) { return $true }
  }
  elseif ($hfind($1,$+($2,.admin),1,W).item) {
    %b = $remove($hfind($1,$+($2,.admin),1,W).item,.admin)
    if ($2 iswm %b || %b iswm $2) { return $true }
  }
}
alias -l getaccess {
  var %a = 1, %b, %c = $iif(@ !isin $3,$+($3,!,$hget($1,$+($3,.host))),$3), %d,%e, %f, %x = 1, %y
  if ($hfind($1,$+(%c,.,$2,.access),1,W).item) {
    %y = $hget($1,$ifmatch)
    while ($hfind($1,$+(%c,.,$2,.access),%x,W).item) {
      %f = $hget($1,$ifmatch)
      if (%f > %y) { %y = %f }
      inc %x
    }
    return %y
  }
}
alias -l isexempt {
  ;$1=socket,$2=channel,$3=host
  var %a = 1, %b
  while ($hget($+($1,.,$hget(cgsb,$+($1,.network)),.,$2,.exempts),%a).item) {
    %b = $ifmatch
    if (%b iswm $3) { return $true }
    inc %a
  }
}

;============================== EVENTS
on *:signal:access:{
  var %a = $hget(cgsb,buffer)
  tokenize 32 %a
  if ($2 == join) {
    var %a = $remove($3,:), %b, %c, %d, %e
    if ($hget(cgsb,$+($cgsbsock,.nick)) != $gettok($mid($1,2,$len($1)),1,33)) {
      if (!$exists($qt($scriptdirblack.txt))) { write -c $qt($scriptdirblack.txt) }
      if (!$exists($qt($scriptdirident.txt))) { write -c $qt($scriptdirident.txt) }
      %b = $hfind($cgsbsock,$+($mid($1,2,$len($1)),.,$hget(cgsb,$+($cgsbsock,.network)),.,%a,.black),1,W).item
      %c = $iif($isadmin($cgsbsock,$mid($1,2,$len($1))),5,$iif($getaccess($cgsbsock,%a,$mid($1,2,$len($1))),$ifmatch,0))
      %d = $hfind($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,%a,.exempts),$mid($1,2,$len($1)),1,W).item
      %e = $hget($cgsbsock,%b)
      var %ident = $gettok($gettok($mid($1,2,$len($1)),1,64),2,33), %nick = $gettok($mid($1,2,$len($1)),1,33)
      if (!$ismode($cgsbsock,@,%a)) { return }
      elseif (%b && %c == 0 && !%d) { sockwrite -n $cgsbsock mode %a +b $remove(%b,$+(.,%a),.black,$+(.,$hget(cgsb,$+($cgsbsock,.network)))) | sockwrite -n $cgsbsock kick %a $gettok($mid($1,2,$len($1)),1,33) $+(:,%e) }
      elseif (%c == 0 && $read($qt($scriptdirblack.txt),w,*!*@ $+ $gettok($mid($1,2,$len($1)),2,64) *)) { var %j = $read($qt($scriptdirblack.txt),w,*!*@ $+ $gettok($mid($1,2,$len($1)),2,64) *) | sockwrite -n $cgsbsock mode %a +b $gettok(%j,1,32) | sockwrite -n $cgsbsock kick %a $gettok($mid($1,2,$len($1)),1,33) $+(:,$gettok(%j,2-,32)) }
      elseif (%c <= 1 && ~ isin %ident && $read($qt($scriptdirident.txt),w,$remove(%ident,~)) && $read($qt($scriptdirident.txt),w,%nick)) { var %j = Spam Bot | sockwrite -n $cgsbsock mode %a +b $+(*!*@,$gettok($mid($1,2,$len($1)),2,64)) | sockwrite -n $cgsbsock kick %a $gettok($mid($1,2,$len($1)),1,33) $+(:,%j) }
      elseif (%c isnum 2-5 && $hget(cgsb,$+($cgsbsock,.oponjoin)) == yes) { .timer -o 1 3 checkstatus $cgsbsock %a $gettok($mid($1,2,$len($1)),1,33) @ }
      elseif (%c == 1 && $hget(cgsb,$+($cgsbsock,.voiceonjoin)) == yes) { .timer -o 1 3 checkstatus $cgsbsock %a $gettok($mid($1,2,$len($1)),1,33) + }
    }
  }
  elseif ($2 == privmsg) {
    var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
    var %a = $hget($cgsbsock,access), %c = $hget($cgsbsock,$+($6,.,$3,.black))
    if ($left($3,1) != $chr(35)) {
      if (:access == $4 && $left($5,1) == $chr(35)) {
        if ($5) { 
          var %f = $iif($chr(33) isin $6,$strip($6),$+($remove($strip($6),~,&,@,%,+),!,$hget($cgsbsock,$+($remove($strip($6),~,&,@,%,+),.host))))
          var %b = $iif($isadmin($cgsbsock,%f),5,$iif($getaccess($cgsbsock,$5,%f),$ifmatch,0))
          var %z = %b
          sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))),$iif($chr(33) !isin $6,$remove($strip($6),~,&,%,@,+),$strip($6))) $+($chr(40),$iif(%z,%z,0),$chr(41)) $+(,$iif($replace(%z,5,admin,4,founder,3,sop,2,aop,1,avoice),$ifmatch,none),) $chr(3)
        }
        else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))),$gettok($mid($1,2,$len($1)),1,33)) $+($chr(40),$iif(%a,%a,0),$chr(41)) $+($chr(2),$iif($replace(%a,5,admin,4,founder,3,sop,2,aop,1,avoice),$ifmatch,none),$chr(2)) $chr(3) }
        sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
        .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
      }
      elseif (:add == $4 && $left($5,1) == $chr(35)) {
        if ($6 isnum 1-4) {
          var %w = $remove($strip($7),~,&,%,@,+), %q = $iif($chr(33) isin $strip($7),$strip($7), $+(%w,!,$hget($cgsbsock,$+(%w,.host))))
          var %r = $iif($isadmin($cgsbsock,%q),5,$iif($getaccess($cgsbsock,$5,%q),$ifmatch,0))
          %q = $mask(%q,$hget(cgsb,$+($cgsbsock,.masks)))
          if (!$7) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No entry specified. Syntax: $+($chr(2),add [1-4] nick!user@host.com,$chr(2)) $chr(3) }
          elseif (%a <= $6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to add nicks to this level. $chr(3) }
          elseif ($chr(33) !isin %q) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+($chr(2),$7,$chr(2)) is an invalid nick/host. $chr(3) }
          else {
            hadd $cgsbsock $+(%q,.,$5,.access) $6
            hsave $cgsbsock $+(",$scriptdir,$cgsbsock,.dat")
            sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully added $+($chr(2),$iif($chr(33) isin $strip($7),%q,%w),$chr(2)) as level $+(,$replace($6,4,founder,3,sop,2,aop,1,avoice),) in the access list. $chr(3)
          }
        }
        elseif ($6 == black) {
          if (!$7 || !$8) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No entry specified. Syntax: $+($chr(2),add black nick!user@host.com <reason>,$chr(2)) $chr(3) }
          elseif (%a < 3) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to add nicks to this level. $chr(3) }
          elseif ($chr(33) isin $7) {
            if ($hfind($cgsbsock,$+($strip($7),.,$5,.black),1,W)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+(,$strip($6),) already exists in the black list. $chr(3) }
            elseif ($isadmin($cgsbsock,$strip($7)) || $getaccess($cgsbsock,$5,$strip($7))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+(,$strip($7),) has $+(,$replace($iif($isadmin($cgsbsock,$strip($7)),admin,$getaccess($cgsbsock,$5,$strip($7))),4,founder,3,sop,2,aop,1,avoice),) access. $chr(3) }
            else {
              hadd $cgsbsock $+($strip($7),.,$5,.black) $8-
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully added $+(,$strip($7),) as level black in the access list. $chr(3)
            }
          }
          else {
            sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid host. $chr(3)
          }
        }
        else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid "add" entry. Syntax: $+($chr(2),add [#chan] [1-4/black] nick!user@host.com,$chr(2)) $chr(3) }
      }
      elseif (:del == $4 && $left($5,1) == $chr(35)) {
        if ($6 isnum 1-4) {
          if (%a <= $6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to delete nicks from this level. $chr(3) }
          elseif (!$7) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No entry specified. Syntax: $+($chr(2),del [#chan] [1-4] [nick/nick!user@host.com],$chr(2)) $chr(3) }
          elseif (!$getaccess($cgsbsock,$5,$7)) {
            if ($chr(33) isin $7) {
              if ($getaccess($cgsbsock,$5,$remove($strip($7),~,&,%,@,+)) != $5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+($chr(2),$7,$chr(2)) does not exist in the $+($chr(2),$replace($6,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3) }
              else { hdel $cgsbsock $+($remove($strip($7),~,&,%,@,+),.,$3,.access) | sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully deleted $+($chr(2),$strip($7),$chr(2)) from level $+($chr(2),$replace($6,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3) }
            }
            else {
              var %w = $remove($strip($7),~,&,%,@,+), %q = $getaccess($cgsbsock,$5,$+(%w,!,$hget($cgsbsock,$+(%w,.host)))), %h = $mask($+(%w,!,$hget($cgsbsock,$+(%w,.host))),$hget(cgsb,$cgsbsock,.masks))
              if ($6 != %q) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+($chr(2),%w,$chr(2)) does not exist in the $+($chr(2),$replace($6,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3) }
              else {
                hdel $cgsbsock $+(%h,.,$5,.access)
                hsave $cgsbsock $+(",$scriptdir,$cgsbsock,.dat")
                sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully deleted $+($chr(2),%w,$chr(2)) from level $+($chr(2),$replace($6,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3)
              }
            }
          }
          else { 
            if ($chr(33) isin $7) { hdel $cgsbsock $+($strip($7),.,$5,.access) }
            else { hdel $cgsbsock $+( $mask( $+($remove($strip($7),~,&,%,@,+),!,$hget($cgsbsock,$+($remove($strip($7),~,&,%,@,+),.host))) ,$hget(cgsb,$+($cgsbsock,.masks))),.,$5,.access) }
            hsave $cgsbsock $+(",$scriptdir,$cgsbsock,.dat")
            sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully deleted $+($chr(2),$iif($chr(33) isin $7,$strip($7),$remove($strip($7),~,&,%,@,+)),$chr(2)) from level $+($chr(2),$replace($6,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3)
          }
        }
        elseif ($6 == black) {
          var %b = $iif($chr(33) isin $strip($7),$strip($7),$remove($strip($7),~,&,%,@,+)), %c = $iif($hfind($cgsbsock,$+(%b,!,$hget($cgsbsock,$+(%b,.host)),.,$5,.black),1,W).item,$ifmatch,$iif($hget($cgsbsock,$+(%b,.,$5,.black)),$+(%b,.,$5,.black)))
          if (%a <= 2) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to delete nicks from this level. $chr(3) }
          elseif (!$7) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No entry specified. Syntax: $+($chr(2),del #chan black nick!user@host.com,$chr(2)) $chr(3) }
          elseif (!%c) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+(,%b,) does not exist in the black list. $chr(3) }
          else {
            hdel $cgsbsock %c
            sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully deleted $+(,%b,) from level black list. $chr(3)
          }
        }
        else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid "del" entry. Syntax: $+($chr(2),del [#chan] [1-4/black] nick!user@host.com,$chr(2)) $chr(3) }
        sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
        .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
      }
      elseif (:wipe == $4 && $left($5,1) == $chr(35)) {
        if ($6 isnum 1-4) {
          if (%a <= $6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to wipe this list. $chr(3) }
          else {
            var %b = 1, %d, %e
            while ($hfind($cgsbsock,$+(*.,$5,.access),%b,w).item) {
              %d = $ifmatch
              %e = $hget($cgsbsock,%d)
              if (%e == $6) { hdel $cgsbsock %d | %b = 0 }
              inc %b
            }
            sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Sucessfully wiped the $+($chr(2),$replace($6,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3)
          }
        }
        elseif ($6 == black) {
          if (%a < 3) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to wipe this list. $chr(3) }
          else {
            var %c = 1, %d, %e
            while ($hfind($cgsbsock,$+(*.,$5,.black),1,w).item) {
              hdel $cgsbsock $ifmatch
              inc %c
            }
            sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Sucessfully wiped the black list. $chr(3)
          }
        }
        else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid "wipe" entry. Syntax: $+($chr(2),wipe [1-3/black],$chr(2)) $chr(3) }

        sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
        .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
      }
    }
    else {
      var %a = $hget($cgsbsock,access), %c = $hget($cgsbsock,$+($6,.,$3,.black))
      if ($+(:,$hget(cgsb,$+($cgsbsock,.prefix)),*) iswm $4) {
        var %p = $hget(cgsb,$+($cgsbsock,.prefix))
        if ($+(:,%p,kickban) != $4 && $+(:,%p,kb) != $4 && $+(:,%p,access) != $4 && $+(:,%p,a) != $4 && $+(:,%p,add) != $4 && $+(:,%p,del) != $4 && $+(:,%p,list) != $4 && $+(:,%p,wipe) != $4 && $+(:,%p,kick) != $4 && $+(:,%p,k) != $4 && $+(:,%p,kb) != $4 && $+(:,%p,op) != $4 && $+(:,%p,deop) != $4 && $+(:,%p,voice) != $4 && $+(:,%p,devoice) != $4 && $+(:,%p,topic) != $4 && $+(:,%p,mode) != $4 && $+(:,%p,unexempt) != $4 && $+(:,%p,exempt) != $4 $&
          && $+(:,%p,uninvite) != $4 && $+(:,%p,invite) != $4 && $+(:,%p,ban) != $4 && $+(:,%p,unban) != $4 && $+(:,%p,addchanops) != $4 && $+(:,%p,o) != $4 && $+(:,%p,v) != $4 && $+(:,%p,t) != $4 && $+(:,%p,m) != $4 && $+(:,%p,b) != $4 && $+(:,%p,ub) != $4 && $+(:,%p,e) != $4 && $+(:,%p,ue) != $4 && $+(:,%p,i) != $4 && $+(:,%p,ui) != $4 && $+(:,%p,aco) != $4 && $+(:,%p,deopvoice) != $4 && $+(:,%p,dov) != $4 $&
          && $+(:,%p,ov) != $4 && $+(:,%p,opvoice) != $4 && $+(:,%p,vo) != $4) {
          return
        }
        elseif ($+(:,%p,access) == $4 || $+(:,%p,a) == $4) {
          if ($5) { 
            var %f = $iif($chr(33) isin $5,$strip($5),$+($remove($strip($5),~,&,@,%,+),!,$hget($cgsbsock,$+($remove($strip($5),~,&,@,%,+),.host))))
            var %b = $iif($isadmin($cgsbsock,%f),5,$iif($getaccess($cgsbsock,$3,%f),$ifmatch,0))
            var %z = %b
            sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))),$iif($chr(33) !isin $5,$remove($strip($5),~,&,%,@,+),$strip($5))) $+($chr(40),$iif(%z,%z,0),$chr(41)) $+(,$iif($replace(%z,5,admin,4,founder,3,sop,2,aop,1,avoice),$ifmatch,none),) $chr(3)
          }
          else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))),$gettok($mid($1,2,$len($1)),1,33)) $+($chr(40),$iif(%a,%a,0),$chr(41)) $+($chr(2),$iif($replace(%a,5,admin,4,founder,3,sop,2,aop,1,avoice),$ifmatch,none),$chr(2)) $chr(3) }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,wipe) == $4 || $+(:,%p,w) == $4) {
          if ($5 isnum 1-4) {
            if (%a <= $5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to wipe this list. $chr(3) }
            else {
              var %b = 1, %d, %e
              while ($hfind($cgsbsock,$+(*.,$3,.access),%b,w).item) {
                %d = $ifmatch
                %e = $hget($cgsbsock,%d)
                if (%e == $5) { hdel $cgsbsock %d | %b = 0 }
                inc %b
              }
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Sucessfully wiped the $+($chr(2),$replace($5,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3)
            }
          }
          elseif ($5 == black) {
            if (%a < 3) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to wipe this list. $chr(3) }
            else {
              var %c = 1, %d, %e
              while ($hfind($cgsbsock,$+(*.,$3,.black),1,w).item) {
                hdel $cgsbsock $ifmatch
                inc %c
              }
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Sucessfully wiped the black list. $chr(3)
            }
          }
          else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid "wipe" entry. Syntax: $+($chr(2),%p,wipe [1-3/black],$chr(2)) $chr(3) }

          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,list) == $4 || $+(:,%p,l) == $4) {
          if ($5 isnum 1-4) {
            var %search = $iif($6,$6,*)
            if ($hfind($cgsbsock,$+(%search,.,$3,.access),0,w).item > 20) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Too many results! Try using a wildcard! $chr(3) }
            elseif (%a < $5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to view this list. $chr(3) }
            else {
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))),$chr(2),$replace($5,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list: $chr(3)
              var %c = 1, %d, %e = 0
              while ($hfind($cgsbsock,$+(*.,$3,.access),%c,w).item) {
                %d = $ifmatch
                if ($hget($cgsbsock,%d) == $5) { inc %e | sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))),$chr(40),%e,$chr(41)) $remove(%d,$+(.,$3,.access)) $chr(3) }
                inc %c
              }
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ End of list. $chr(3)
            }
          }
          elseif ($5 == black) {
            var %search = $iif($6,$6,*)
            if ($hfind($cgsbsock,$+(%search,.,$3,.black),0,w).item > 20) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Too many results! Try using a wildcard! $chr(3) }
            elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to view this list. $chr(3) }
            else {
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))),$chr(2),black,$chr(2)) list: $chr(3)
              var %c = 1, %d
              while ($hfind($cgsbsock,$+(%search,.,$3,.black),%c,w).item) {
                %d = $ifmatch
                sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))),$chr(40),%c,$chr(41)) $remove(%d,.black,$cgsbsock,$+(.,$hget(cgsb,$+($cgsbsock,.network))),$+(.,$wildtok(%d,#*,1,46))) $hget($cgsbsock,%d) $chr(3)
                inc %c
              }
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ End of list.
            }
          }
          else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid "list" entry. Syntax: $+(,$hget(cgsb,$+($cgsbsock,.prefix)),list [1-4/black]) $chr(3) }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 3 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,add) == $4) {
          if ($5 isnum 1-4) {
            var %w = $remove($strip($6),~,&,%,@,+), %q = $iif($chr(33) isin $strip($6),$strip($6), $+(%w,!,$hget($cgsbsock,$+(%w,.host))))
            var %r = $iif($isadmin($cgsbsock,%q),5,$iif($getaccess($cgsbsock,$3,%q),$ifmatch,0))
            %q = $mask(%q,$hget(cgsb,$+($cgsbsock,.masks)))
            if (!$6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No entry specified. Syntax: $+($chr(2),$hget(cgsb,$+($cgsbsock,.prefix)),add [1-4] nick!user@host.com,$chr(2)) $chr(3) }
            elseif (%a <= $5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to add nicks to this level. $chr(3) }
            elseif ($chr(33) !isin %q) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+($chr(2),$6,$chr(2)) is an invalid nick/host. $chr(3) }
            else {
              hadd $cgsbsock $+(%q,.,$3,.access) $5
              hsave $cgsbsock $+(",$scriptdir,$cgsbsock,.dat")
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully added $+($chr(2),$iif($chr(33) isin $strip($6),%q,%w),$chr(2)) as level $+(,$replace($5,4,founder,3,sop,2,aop,1,avoice),) in the access list. $chr(3)
            }
          }
          elseif ($5 == black) {
            if (!$6 || !$7) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No entry specified. Syntax: $+($chr(2),$hget(cgsb,$+($cgsbsock,.prefix)),add black nick!user@host.com <reason>,$chr(2)) $chr(3) }
            elseif (%a < 3) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to add nicks to this level. $chr(3) }
            elseif ($chr(33) isin $6) {
              if ($hfind($cgsbsock,$+($strip($6),.,$3,.black),1,W)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+(,$strip($6),) already exists in the black list. $chr(3) }
              elseif ($isadmin($cgsbsock,$strip($6)) || $getaccess($cgsbsock,$3,$strip($6))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+(,$strip($6),) has $+(,$replace($iif($isadmin($cgsbsock,$strip($6)),admin,$getaccess($cgsbsock,$3,$strip($6))),4,founder,3,sop,2,aop,1,avoice),) access. $chr(3) }
              else {
                hadd $cgsbsock $+($strip($6),.,$3,.black) $7-
                sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully added $+(,$strip($6),) as level black in the access list. $chr(3)
              }
            }
            else {
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid host. $chr(3)
            }
          }
          else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid "add" entry. Syntax: $+($chr(2),%p,add [1-4/black] nick!user@host.com,$chr(2)) $chr(3) }
        }
        elseif ($+(:,%p,del) == $4) {
          if ($5 isnum 1-4) {
            if (%a <= $5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to delete nicks from this level. $chr(3) }
            elseif (!$6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No entry specified. Syntax: $+($chr(2),$hget($cgsbsock,prefix),del [1-4] [nick/nick!user@host.com,$chr(2)) $chr(3) }
            elseif (!$getaccess($cgsbsock,$3,$6)) {
              if ($chr(33) isin $6) {
                if ($getaccess($cgsbsock,$3,$remove($strip($6),~,&,%,@,+)) != $5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+($chr(2),$6,$chr(2)) does not exist in the $+($chr(2),$replace($5,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3) }
                else { hdel $cgsbsock $+($remove($strip($6),~,&,%,@,+),.,$3,.access) | sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully deleted $+($chr(2),$strip($6),$chr(2)) from level $+($chr(2),$replace($5,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3) }
              }
              else {
                var %w = $remove($strip($6),~,&,%,@,+), %q = $getaccess($cgsbsock,$3,$+(%w,!,$hget($cgsbsock,$+(%w,.host)))), %h = $mask($+(%w,!,$hget($cgsbsock,$+(%w,.host))),$hget(cgsb,$cgsbsock,.masks))
                if ($5 != %q) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+($chr(2),%w,$chr(2)) does not exist in the $+($chr(2),$replace($5,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3) }
                else {
                  hdel $cgsbsock $+(%h,.,$3,.access)
                  hsave $cgsbsock $+(",$scriptdir,$cgsbsock,.dat")
                  sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully deleted $+($chr(2),%w,$chr(2)) from level $+($chr(2),$replace($5,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3)
                }
              }
            }
            else { 
              if ($chr(33) isin $6) { hdel $cgsbsock $+($strip($6),.,$3,.access) }
              else { hdel $cgsbsock $+( $mask( $+($remove($strip($6),~,&,%,@,+),!,$hget($cgsbsock,$+($remove($strip($6),~,&,%,@,+),.host))) ,$hget(cgsb,$+($cgsbsock,.masks))),.,$3,.access) }
              hsave $cgsbsock $+(",$scriptdir,$cgsbsock,.dat")
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully deleted $+($chr(2),$iif($chr(33) isin $6,$strip($6),$remove($strip($6),~,&,%,@,+)),$chr(2)) from level $+($chr(2),$replace($5,4,founder,3,sop,2,aop,1,avoice),$chr(2)) access list. $chr(3)
            }
          }
          elseif ($5 == black) {
            var %b = $iif($chr(33) isin $strip($6),$strip($6),$remove($strip($6),~,&,%,@,+)), %c = $iif($hfind($cgsbsock,$+(%b,!,$hget($cgsbsock,$+(%b,.host)),.,$3,.black),1,W).item,$ifmatch,$iif($hget($cgsbsock,$+(%b,.,$3,.black)),$+(%b,.,$3,.black)))
            if (%a <= 2) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to delete nicks from this level. $chr(3) }
            elseif (!$6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No entry specified. Syntax: $+($chr(2),.del black nick!user@host.com,$chr(2)) $chr(3) }
            elseif (!%c) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+(,%b,) does not exist in the black list. $chr(3) }
            else {
              hdel $cgsbsock %c
              sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully deleted $+(,%b,) from level black list. $chr(3)
            }
          }
          else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid "del" entry. Syntax: $+($chr(2),%p,del [1-4/black] nick!user@host.com,$chr(2)) $chr(3) }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,deopvoice) == $4 || $+(:,%p,dov) == $4) {
          var %me = $iif($5,$5,$gettok($mid($1,2,$len($1)),1,33))
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          var %modes = $iif($isothermode($cgsbsock,@,$3,%me),@) $+ $iif($isothermode($cgsbsock,+,$3,%me),+)
          var %modes = $iif(@ isin %modes,-o) $+ $iif(+ !isin %modes,+v)
          if (%modes) { sockwrite -n $cgsbsock mode $3 %modes %me %me }
          else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You are not opped/devoiced! $chr(3) }
        }
        elseif ($+(:,%p,opvoice) == $4 || $+(:,%p,ov) == $4 || $+(:,%p,vo) == $4) {
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          elseif (!$5) {
            var %me = $gettok($mid($1,2,$len($1)),1,33)
            var %modes = $iif($isothermode($cgsbsock,@,$3,%me),@) $+ $iif($isothermode($cgsbsock,+,$3,%me),+)
            var %modes = $iif(@ !isin %modes,+o,-o) $+ $iif(+ !isin %modes,+v,-v)
            sockwrite -n $cgsbsock mode $3 $replace(%modes,+o+v,+ov,-o-v,-ov) %me %me
          }
          else {
            if (!$hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.nicks),$remove($strip($5),~,&,%,@,+))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No such person $+(,$remove($strip($5),~,&,%,@,+),) on $+(,$3,.) $chr(3) }
            var %me = $remove($strip($5),~,&,%,@,+)
            var %modes = $iif($isothermode($cgsbsock,@,$3,%me),@) $+ $iif($isothermode($cgsbsock,+,$3,%me),+)
            var %modes = $iif(@ !isin %modes,+o,-o) $+ $iif(+ !isin %modes,+v,-v)
            sockwrite -n $cgsbsock mode $3 $replace(%modes,+o+v,+ov,-o-v,-ov) %me %me
          }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,op) == $4 || $+(:,%p,o) == $4) {
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          elseif (!$5) {  sockwrite -n $cgsbsock mode $3 $iif($isothermode($cgsbsock,@,$3,$gettok($mid($1,2,$len($1)),1,33)),-o,+o) $gettok($mid($1,2,$len($1)),1,33) }
          else {  sockwrite -n $cgsbsock mode $3 $iif($isothermode($cgsbsock,@,$3,$remove($strip($5),~,&,%,@,+)),-o,+o) $remove($strip($5),~,&,%,@,+) }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,voice) == $4 || $+(:,%p,v) == $4) {
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (%a == 0) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          elseif (!$5) { sockwrite -n $cgsbsock mode $3 $iif($isothermode($cgsbsock,+,$3,$gettok($mid($1,2,$len($1)),1,33)),-v,+v) $gettok($mid($1,2,$len($1)),1,33) }
          else { sockwrite -n $cgsbsock mode $3 $iif($isothermode($cgsbsock,+,$3,$remove($strip($5),~,&,%,@,+)),-v,+v) $remove($strip($5),~,&,%,@,+) }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,kickban) == $4 || $+(:,%p,kb) == $4) {
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          else {
            var %c = 1, %d, %e, %z, %h = 0, %k, %j
            while ($gettok($remove($strip($5),~,&,%,@,+),%c,44)) {
              %d = $ifmatch
              %j = $+(%d,!,$hget($cgsbsock,$+(%d,.host)))
              %z = $iif($isadmin($cgsbsock,%j),5,$iif($getaccess($cgsbsock,$3,%j),$ifmatch,0))
              if (%d == $hget(cgsb,$+($cgsbsock,.nick))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I will not kick/ban myself. $chr(3) }
              elseif ($chr(33) isin %d) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You must specify a nickname to kick/ban. $chr(3) }
              elseif (!$hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.nicks),%d)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No such person $+(,%d,) on $+(,$3,.) $chr(3) }
              elseif ($isexempt($cgsbsock,$3,%j)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Denied, %j is in the channel exempt list. $chr(3) }
              elseif (%z > 1 && $hget(cgsb,$+($cgsbsock,.protection)) == YES) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+(,%d,) has $+(,$replace(%z,5,admin,4,founder,3,sop,2,aop,1,avoice),) access. $chr(3) }
              else {
                inc %h
                sockwrite -n $cgsbsock mode $3 +b $mask(%j,$hget(cgsb,$+($cgsbsock,.masks)))
                sockwrite -n $cgsbsock kick $3 %d $+(:,$iif($6,$6-,Banned))
              }
              inc %c
            }
          }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,kick) == $4 || $+(:,%p,k) == $4) {
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          else {
            var %c = 1, %d, %e, %z, %h = 0, %m
            while ($gettok($remove($strip($5),~,&,%,@,+),%c,44)) {
              %d = $ifmatch
              %m = $+(%d,!,$hget($cgsbsock,$+(%d,.host)))
              %z = $iif($isadmin($cgsbsock,%m),5,$iif($getaccess($cgsbsock,$3,%m),$ifmatch,0))
              if (%d == $hget(cgsb,$+($cgsbsock,.nick))) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I will not kick myself. $chr(3) }
              elseif (!$hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.nicks),%d)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No such person $+(,%d,) on $+(,$3,.) $chr(3) }
              elseif ($isexempt($cgsbsock,$3,%m)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Denied, %m is in the channel exempt list. $chr(3) }
              elseif (%z >= 1 && $hget(cgsb,$+($cgsbsock,.protection)) == YES) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+(,%d,) has $+(,$replace(%z,5,admin,4,founder,3,sop,2,aop,1,avoice),) access. $chr(3) }
              else { inc %h | sockwrite -n $cgsbsock kick $3 %d $+(:,$iif($6,$6-,No Reason Entered)) }
              inc %c
            }
          }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,uninvite) == $4 || $+(:,%p,ui) == $4) {
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No invite specified. $chr(3) }
          if ($chr(44) !isin $5) {
            var %w = $remove($strip($5),~,&,%,@,+)
            var %j = $+(%w,!,$hget($cgsbsock,$+(%w,.host)))
            var %q = $iif($chr(33) !isin %w,$mask(%j,$hget(cgsb,$+($cgsbsock,.masks))),$strip($5))
            if (!$hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.invites),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ ,$iif($chr(33) isin $5,$strip($5),%q),) is not invited. $chr(3) }
            else { sockwrite -n $cgsbsock mode $3 -I %q }
          }
          else {
            var %c = 1, %d, %e, %q, %j, %w
            while ($gettok($strip($5),%c,44)) {
              %d = $ifmatch
              %w = $remove(%d,~,&,%,@,+)
              %j = $+(%w,!,$hget($cgsbsock,$+(%w,.host)))
              %q = $iif($chr(33) isin %d,%d,$mask(%j,$hget(cgsb,$+($cgsbsock,.masks))))
              if (!$hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.invites),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ ,%q,) is not invited. $chr(3) }
              else { %e = $addtok(%e,%q,32) }
              inc %c
            }
            appendmode $cgsbsock $3 $+(-,$str(I,$numtok(%e,32))) %e
          }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,invite) == $4 || $+(:,%p,i) == $4) {
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No invite specified. $chr(3) }
          if ($chr(44) !isin $5) {
            var %w = $remove($strip($5),~,&,%,@,+)
            var %j = $+(%w,!,$hget($cgsbsock,$+(%w,.host)))
            var %q = $iif($chr(33) !isin %w, $mask(%j,$hget(cgsb,$+($cgsbsock,.masks))) ,$strip($5))
            if ($hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.invites),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ ,$iif($chr(33) isin $5,$strip($5),%q),) is already invited. $chr(3) }
            else { sockwrite -n $cgsbsock mode $3 +I %q }
          }
          else {
            var %c = 1, %d, %e, %r, %q,%w,%j
            while ($gettok($strip($5),%c,44)) {
              %d = $ifmatch
              %w = $remove(%d,~,&,%,@,+)
              %j = $+(%w,!,$hget($cgsbsock,$+(%w,.host)))
              %q = $iif($chr(33) isin %d,%d,$mask(%j,$hget(cgsb,$+($cgsbsock,.masks))))
              if ($hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.invites),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ ,%q,) is already invited. $chr(3) }
              else { %e = $addtok(%e,%q,32) }
              inc %c
            }
            appendmode $cgsbsock $3 $+(+,$str(I,$numtok(%e,32))) %e
          }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,unexempt) == $4 || $+(:,%p,ue) == $4) {
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No exempt specified. $chr(3) }
          if ($chr(44) !isin $5) {
            var %w = $remove($strip($5),~,&,%,@,+)
            var %j = $+(%w,!,$hget($cgsbsock,$+(%w,.host)))
            var %q = $iif($chr(33) !isin %w,$mask(%j,$hget(cgsb,$+($cgsbsock,.masks))),$strip($5))
            if (!$hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.exempts),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ ,%q,) is not exempted. $chr(3) }
            else { sockwrite -n $cgsbsock mode $3 -e %q }
          }
          else {
            var %c = 1, %d, %e, %q, %w, %j
            while ($gettok($strip($5),%c,44)) {
              %d = $ifmatch
              %w = $remove(%d,~,&,%,@,+)
              %j = $+(%w,!,$hget($cgsbsock,$+(%w,.host)))
              %q = $iif($chr(33) isin %d,%d,$mask(%j,$hget(cgsb,$+($cgsbsock,.masks))))
              if (!$hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.exempts),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ ,%q,) is not exempted. $chr(3) }
              else { %e = $addtok(%e,%q,32) }
              inc %c
            }
            appendmode $cgsbsock $3 $+(-,$str(e,$numtok(%e,32))) %e
          }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,unban) == $4 || $+(:,%p,ub) == $4) {
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) | return }
          elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) | return }
          elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No ban specified. $chr(3) | return }
          if ($chr(44) !isin $remove($strip($5),~,&,%,@,+)) {
            var %w = $remove($strip($5),~,&,%,@,+)
            var %j = $+(%w,!,$hget($cgsbsock,$+(%w,.host)))
            var %q = $iif($chr(33) !isin %w,$mask(%j,$hget(cgsb,$+($cgsbsock,.masks))),$strip($5))
            if (!$hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.bans),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ ,$iif($chr(33) isin $remove($strip($5),~,&,%,@,+),$strip($5),$remove($strip($5),~,&,%,@,+)),) is not banned. $chr(3) }
            else { sockwrite -n $cgsbsock mode $3 -b %q }
          }
          else {
            var %c = 1, %d, %e, %q, %j
            while ($gettok($strip($5),%c,44)) {
              %d = $ifmatch
              %j = $+(%d,!,$hget($cgsbsock,$+(%d,.host)))
              %q = $iif($chr(33) isin %d,%d,$mask(%j,$hget(cgsb,$+($cgsbsock,.masks))))
              if (!$hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.bans),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ ,%d,) is not banned. $chr(3) }
              else { %e = $addtok(%e,$iif(%q,%q,%d),32) }
              inc %c
            }
            appendmode $cgsbsock $3 $+(-,$str(b,$numtok(%e,32))) %e
          }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,ban) == $4 || $+(:,%p,b) == $4) {
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) | return }
          elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) | return }
          elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No ban specified. $chr(3) | return }
          if ($chr(44) !isin $5) {
            var %w = $remove($strip($5),~,&,%,@,+)
            var %j = $+(%w,!,$hget($cgsbsock,$+(%w,.host)))
            var %l = $+($hget(cgsb,$+($cgsbsock,.nick)),!,$hget(cgsb,$+($cgsbsock,.nick)))
            var %q = $iif($chr(33) isin $strip($5),$strip($5), $mask(%j,$hget(cgsb,$+($cgsbsock,.masks))) )
            var %r = $iif($isadmin($cgsbsock,%q),5,$getaccess($cgsbsock,$3,%q))
            if ($hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.bans),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,%q,) is already banned. $chr(3) }
            elseif (%q iswm %l) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I will not ban myself. $chr(3) }
            elseif ($isexempt($cgsbsock,$3,%j)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Denied, %j is in the channel exempt list. $chr(3) }
            elseif (%r > 1 && $hget(cgsb,$+($cgsbsock,.protection)) == YES) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+(,$iif($chr(33) !isin $5,$remove($strip($5),~,&,%,@,+),$strip($5)),) has $+(,$replace(%r,5,admin,4,founder,3,sop,2,aop,1,avoice),) access, And my access protection is enabled. $chr(3) }
            else { sockwrite -n $cgsbsock mode $3 +b %q }
          }
          else {
            var %c = 1, %d, %e, %r, %q, %j, %l
            while ($gettok($strip($5),%c,44)) {
              %d = $ifmatch
              %r = $iif($isadmin($cgsbsock,$+(%d,!,$hget($+($hget($cgsbsock,network),.,$3,.stats),$+(%d,.host)))),5,$getaccess($cgsbsock,$3,$+(%d,!,$hget($+($hget($cgsbsock,network),.,$3,.stats),$+(%d,.host)))))
              %j = $+(%d,!,$hget($cgsbsock,$+(%d,.host)))
              %l = $+($hget(cgsb,$+($cgsbsock,.nick)),!,$hget(cgsb,$+($cgsbsock,.nick)))
              %q = $mask(%j,$hget(cgsb,$+($cgsbsock,.masks)))
              %q = $iif($chr(33) isin %d,%d,$+($remove($strip($5),~,&,%,@,+),!,$mask($hget($+($hget($cgsbsock,network),.,$3,.stats),$+($remove($strip($5),~,&,%,@,+),.host)),$hget($hget($cgsbsock,network),masks))))
              if ($hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.bans),%d) || $hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.bans),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ ,%d,) is already banned. $chr(3) }
              elseif (%d iswm %l || %q iswm %l) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I will not ban myself. $chr(3) }
              elseif ($isexempt($cgsbsock,$3,%j)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Denied, %j is in the channel exempt list. $chr(3) }
              elseif (%r > 1 && $hget(cgsb,$+($cgsbsock,.protection)) == YES) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, $+(,%d,) has $+(,$replace(%r,5,admin,4,founder,3,sop,2,aop,1,avoice),) access, And my access protection is enabled. $chr(3) }
              else { %e = $addtok(%e,$iif(%q,%q,%d),32) }
              inc %c
            }
            appendmode $cgsbsock $3 $+(+,$str(b,$numtok(%e,32))) %e
          }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,topic) == $4) {
          if (%a < 2) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          elseif (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No topic specified. $chr(3) }
          elseif ($hget($cgsbsock,$+($3,.topic)) == $5-) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Topic is already that. $chr(3) }
          else { sockwrite -n $cgsbsock topic $3 $+(:,$5-) | sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Topic set. $chr(3) }
        }
        elseif ($+(:,%p,mode) == $4) {
          if (%a < 2) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          elseif (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No mode specified. $chr(3) }
          else { sockwrite -n $cgsbsock mode $3 $5- }
        }
        elseif ($+(:,%p,exempt) == $4 || $+(:,%p,e) == $4) {
          if (!$ismode($cgsbsock,@,$3)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ I am not opped. $chr(3) }
          elseif (%a <= 1) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access for this command. $chr(3) }
          elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No exempt specified. $chr(3) }
          if ($chr(44) !isin $5) {
            var %w = $remove($strip($5),~,&,%,@,+)
            var %j = $+(%w,!,$hget($cgsbsock,$+(%w,.host)))
            var %q = $iif($chr(33) !isin %w, $mask(%j,$hget(cgsb,$+($cgsbsock,.masks))),$strip($5))
            if ($hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.exempts),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ ,$iif($chr(33) isin $5,$strip($5),%q),) is already exempted. $chr(3) }
            else { sockwrite -n $cgsbsock mode $3 +e %q }
          }
          else {
            var %c = 1, %d, %e, %r, %q,%w,%q, %j
            while ($gettok($strip($5),%c,44)) {
              %d = $ifmatch
              %w = $remove(%d,~,&,%,@,+)
              %j = $+(%w,!,$hget($cgsbsock,$+(%w,.host)))
              %q = $iif($chr(33) isin %d,%d,$mask(%j,$hget(cgsb,$+($cgsbsock,.masks))))
              if ($hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.exempts),%q)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+($+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ ,%q,) is already exempted. $chr(3) }
              else { %e = $addtok(%e,%q,32) }
              inc %c
            }
            appendmode $cgsbsock $3 $+(+,$str(e,$numtok(%e,32))) %e
          }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
        elseif ($+(:,%p,addchanops) == $4 || $+(:,%p,aco) == $4) {
          var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
          if ($5 isnum 1-4) {
            if (%a < 3) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to add nicks to this level. $chr(3) }
            elseif (%a <= $5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not possess enough access to add nicks to this level. $chr(3) }
            else {
              var %z = 1, %x, %ac = 0, %n, %v = 0, %r = 0, %h, %n2
              while ($hget($+($cgsbsock,.,$hget(cgsb,$+($cgsbsock,.network)),.,$3,.nicks),%z).item) {
                %x = $ifmatch
                if (%x == $hget(cgsb,$+($cgsbsock,.nick))) { inc %z | continue }
                %n = $+(%x,!,$hget($cgsbsock,$+(%x,.host)))
                %n2 = $mask(%n,$hget(cgsb,$+($cgsbsock,.masks)))
                %h = $iif($isadmin($cgsbsock,%n),5,$iif($getaccess($cgsbsock,$3,%n),$ifmatch,0))
                if ($isothermode($cgsbsock,@,$3,%x) && %h == 0 || $isothermode($cgsbsock,@,$3,%x) && %h < $5 && %h != 4 && %h != 5) { inc %ac | inc %v 3 | inc %r | hadd $cgsbsock $+(%n2,.,$3,.access) $5- | .timer -o 1 $calc(%v + %r) sockwrite -n $cgsbsock notice %x $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You have been given $+(,$replace($5,4,founder,3,sop,2,aop,1,avoice),) access on $+(,$3,.) Type $+(,$hget(cgsb,$+($cgsbsock,.prefix)),help) to learn your new commands. $chr(3) }
                inc %z
              }
              if (%ac > 0) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Successfully added %ac of the $+(,$3,) operators as $+(,$replace($5,4,founders,3,sops,2,aops,1,avoices),.) $chr(3) | hsave $cgsbsock $+(",$scriptdir,$cgsbsock,.dat") }
              else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Unable to comply, All ops are already added to the $+(,$replace($5,4,founders,3,sops,2,aops,1,avoices),) list. $chr(3) }
            }
          }
          else { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No level specified. Syntax: $+($chr(2),$hget(cgsb,$+($cgsbsock,.prefix)),addchanops [1-4],$chr(2)) $chr(3) }
          sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
          .timer -o 1 $iif(%ac,$ifmatch,2) sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
        }
      }
    }
  }
}
