;TITLE ACRO
;AUTHOR entropy
;COMMANDS acro(0)
;VERSION: 1.3
;HELP acro [acronym]|Defines acronyms on channel.|none

;============================== ALIASES

alias -l cgsbsock { return $hget(cgsb,socket) | halt }
alias acro {
  sockclose acro
  sockopen acro all-acronyms.com 80
  sockmark acro $1-
}

alias -l destroyacro {
  hdel $1 acrovalue
  hdel $1 acroword
  hdel $1 acrochannel
  hdel $1 acronick
  hdel $1 acroword
  hdel $1 acrofinish
  hdel $1 acrocontinue
}
alias -l striphtml {
  var %p = 1, %b = $replace($1-,$chr(38),$+($chr(32),$chr(38)),;,$+(;,$chr(32)),>,$+(>,$chr(32)),<,$+($chr(32),<,)), %c
  while ($gettok(%b,%p,32)) {
    %c = $ifmatch
    if (*<* iswm %c || *&*; iswm %c || *</* iswm %c || *solid* iswm %c || *px* iswm %c || *:* iswm %c && $remove(%c,:) !isnum || */* iswm %c || *'* iswm %c || *;* iswm %c || *&* iswm %c || *<*>* iswm %c || *=* iswm %c || *"* iswm %c || *>* iswm %c || $+(*,$chr(40),*) iswm %c || $+(*,$chr(41),*) iswm %c || $+(*,$chr(123),*) iswm %c || $+(*,$chr(125),*) iswm %c) { %b = $remove(%b,%c) | %p = 0 }
    inc %p
  }
  return %b
}


;============================== EVENTS
on *:signal:acro:{
  var %i = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  tokenize 32 %i
  if ($+(:,%p,acro) == $4) {
    if (%a < $getcom(acro)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) }
    elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No acronym specified. $chr(3) }
    else {
      hadd $cgsbsock acronick $gettok($mid($1,2,$len($1)),1,33)
      hadd $cgsbsock acrochannel $3
      hadd $cgsbsock acroword $5-
      acro $cgsbsock $5-
    }
    sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
    .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
  }
}
on *:sockopen:acro:{
  var %t = $gettok($hget(cgsb,$+($sockname,.colors)),1,32), %u = $gettok($hget(cgsb,$+($sockname,.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),acronick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3) | return }
  sockwrite -n $sockname GET $+(/,$gettok($sock($sockname).mark,2-,32)) HTTP/1.1
  sockwrite -n $sockname Host: $+(www.all-acronyms.com,$str($crlf, 2))
}
on *:sockread:acro:{
  var %t = $gettok($hget(cgsb,$+($sockname,.colors)),1,32), %u = $gettok($hget(cgsb,$+($sockname,.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),acronick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3) | return }
  var %a, %b
  sockread -f %a
  tokenize 32 %a
  if ((*class="rank_up* iswm $1- && !%answer) || (*class="rank_dn"* iswm $1- && !%answer)) {
    var %tmp = $findtok($1-,class="rank_up,1,32)
    if (!%tmp) { %tmp = $findtok($1-,class="rank_dn",1,32) }
    %tmp = $gettok($1-,$+(%tmp,-),32)
    var %start = $findtok(%tmp,$wildtok(%tmp,*/>*,1,32),1,32)
    var %end = $findtok(%tmp,$wildtok(%tmp,*<a*,1,32),1,32)
    %answer = $remove($gettok(%tmp,$+(%start,-,%end),32),/>,<a)
  }
  if (%answer) { var %n = $iif($len(%answer) >= 850,$+($mid(%answer,1,850),...),%answer) | sockwrite -n $gettok($sock($sockname).mark,1,32) privmsg $hget($gettok($sock($sockname).mark,1,32),acrochannel) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ $+(,$hget($gettok($sock($sockname).mark,1,32),acroword),) = %n $chr(3) | unset %answer | unset %found | destroyacro $gettok($sock($sockname).mark,1,32) | sockclose acro | return }
  if (*</html>* iswm $1- && !%answer) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),acronick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Nothing found. $chr(3) }
}
