;TITLE SPELL
;AUTHOR entropy
;COMMANDS spell(0)
;VERSION: 1.1
;HELP spell [word]|Displays correct spelling of word.|none

;============================== ALIASES
alias spell {
  sockclose spelling
  sockopen spelling dictionary.reference.com 80
  sockmark spelling $1-
}
alias -l striphtml {
  var %p = 1, %b = $replace($1-,$chr(38),$+($chr(32),$chr(38)),;,$+(;,$chr(32)),>,$+(>,$chr(32)),<,$+($chr(32),<,)), %c
  while ($gettok(%b,%p,32)) {
    %c = $ifmatch
    if (*<* iswm %c || *&*; iswm %c || *</* iswm %c || *solid* iswm %c || *px* iswm %c || *:* iswm %c && $remove(%c,:) !isnum || */* iswm %c || *'* iswm %c || *;* iswm %c || *&* iswm %c || *<*>* iswm %c || *=* iswm %c || *"* iswm %c || *>* iswm %c || $+(*,$chr(40),*) iswm %c || $+(*,$chr(41),*) iswm %c || $+(*,$chr(123),*) iswm %c || $+(*,$chr(125),*) iswm %c) { %b = $remove(%b,%c) | %p = 0 }
    inc %p
  }
  return %b
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }
;============================== EVENTS
on *:signal:spell:{
  var %z = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  tokenize 32 %z
  if ($2 == privmsg && $left($3,1) == $chr(35) && $+(:,%p,*) iswm $4) {
    if ($+(:,%p,spell) == $4) {
      if (%a < $getcom(spell)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
      elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u))) No word specified. $chr(3) }
      else {
        hadd $cgsbsock spellingnick $gettok($mid($1,2,$len($1)),1,33) 
        hadd $cgsbsock spellingchannel $3
        spell $cgsbsock $5-
      }
      sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
      .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
    }
  }
}
on *:sockopen:spelling:{
  var %t = $gettok($hget(cgsb,$+($gettok($sock(spelling).mark,1,32),.colors)),1,32), %u = $gettok($hget(cgsb,$+($gettok($sock(spelling).mark,1,32),.colors)),2,32)
  if ($sockerr > 0) {
    sockwrite -n $gettok($sock(spelling).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),spellingnick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3)
    return 
  }
  sockwrite -n $sockname GET $+(http://dictionary.reference.com/browse/,$gettok($sock($sockname).mark,2-,32)) HTTP/1.1
  sockwrite -n $sockname Host: $+(dictionary.reference.com,$str($crlf, 2))
}
on *:sockread:spelling:{
  var %t = $gettok($hget(cgsb,$+($gettok($sock(spelling).mark,1,32),.colors)),1,32), %u = $gettok($hget(cgsb,$+($gettok($sock(spelling).mark,1,32),.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock(spelling).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),spellingnick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3) | return }
  var %a
  sockread %a
  %a = $mid(%a,1,800)
  tokenize 32 %a
  ;if ($1) { echo -s $1- }
  if (*Did you mean* iswm $striphtml($1-)) { sockwrite -n $gettok($sock(spelling).mark,1,32) privmsg $hget($gettok($sock($sockname).mark,1,32),spellingchannel) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Spelling: $remove($striphtml($1-),Did you mean) $chr(3) | sockclose spelling | return }
  if (*</html>* iswm $1-) { sockwrite -n $gettok($sock(spelling).mark,1,32) privmsg $hget($gettok($sock($sockname).mark,1,32),spellingchannel) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Spelling: $+(",$gettok($sock(spelling).mark,2,32),") is spelled correctly. $chr(3) }
}
