;TITLE TRANSLATE
;AUTHOR entropy
;COMMANDS translate(0)
;VERSION: 1.3
;HELP translate [lang=>lang] [words]|Where lang is: Arabic=AR,Bulgarian=BG,Chinese (Simplified)=ZH-CN,Chinese (Traditional)=ZH-TW,Croatian=HR,Czech=CS,Danish=DA,Dutch=NL,English=EN,Finnish=FI,French=FR,German=DE,Greek=EL,Hindi=HI,Italian=IT,Japanese=JA,Korean=KO,Norwegian=NO,Polish=PL,Portuguese=PT,Romanian=RO,Russian=RU,Spanish=ES,Swedish=SV|Translates words.|none

;============================== ALIASES


alias -l translate {
  sockclose translate
  sockopen translate google.com 80
  sockmark translate $1 $2-
}

alias -l destroytranslate {
  hdel $1 transvalue
  hdel $1 transword
  hdel $1 transchannel
  hdel $1 transnick
  hdel $1 transfinish
  hdel $1 transcontinue
}
alias -l striphtml {
  var %p = 1, %b = $remove($replace($1-,>,$+(>,$chr(32)),<,$+($chr(32),<,)),#), %c
  while ($gettok(%b,%p,32)) {
    %c = $ifmatch
    if (*&*;* iswm %c) {
      var %g = $remove(%c,&,#,1,2,3,4,5,6,7,8,9,0)
      var %left = $gettok(%c,1,38)
      var %right = $gettok(%c,2,59)
      var %middle = $remove(%c,%left,%right,&,$chr(35),;)
      %g = $replace(%g,;,$chr(%middle))
      %b = $replace(%b,%c,%g) | %p = 0
    }
    elseif (*<* iswm %c || *</* iswm %c || *solid* iswm %c || *px* iswm %c || *:* iswm %c && $remove(%c,:) !isnum || */* iswm %c || *'* iswm %c || *&* iswm %c || *<*>* iswm %c || *=* iswm %c || *"* iswm %c || *>* iswm %c || $+(*,$chr(40),*) iswm %c || $+(*,$chr(41),*) iswm %c || $+(*,$chr(123),*) iswm %c || $+(*,$chr(125),*) iswm %c) { %b = $remove(%b,%c) | %p = 0 }
    inc %p
  }
  return %b
}
alias -l cgsbsock { return $hget(cgsb,socket) | halt }

;============================== EVENTS
on *:signal:translate:{
  var %i = $hget(cgsb,buffer), %p = $hget(cgsb,$+($cgsbsock,.prefix))
  var %t = $gettok($hget(cgsb,$+($cgsbsock,.colors)),1,32), %u = $gettok($hget(cgsb,$+($cgsbsock,.colors)),2,32)
  var %a = $hget($cgsbsock,access)
  var %lng = ar,bg,zh-CN,zh-TW,hr,cs,da,nl,en,fi,fr,de,el,hi,it,ja,ko,no,pl,pt,ro,ru,es,sv
  var %lng2 = Arabic=AR,Bulgarian=BG,Chinese (Simplified)=ZH-CN,Chinese (Traditional)=ZH-TW,Croatian=HR,Czech=CS,Danish=DA,Dutch=NL,English=EN,Finnish=FI,French=FR,German=DE,Greek=EL,Hindi=HI,Italian=IT,Japanese=JA,Korean=KO,Norwegian=NO,Polish=PL,Portuguese=PT,Romanian=RO,Russian=RU,Spanish=ES,Swedish=SV
  tokenize 32 %i
  if ($+(:,%p,translate) == $4) {
    var %word1 = $gettok($5,1,61)
    var %word2 = $remove($gettok($5,2,61),>)
    if (%a < $getcom(translate)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ You do not posses enough access for this command. $chr(3) | return }
    elseif (!$5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No languages specified. $chr(3) }
    elseif (*=>* !iswm $5) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ languages must be in the format: lang1=>lang2 $+  $chr(3) }
    elseif (!$6) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ No words specified. $chr(3) }
    elseif (!$istok(%lng,%word1,44) || !$istok(%lng,%word2,44)) { sockwrite -n $cgsbsock notice $gettok($mid($1,2,$len($1)),1,33) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Invalid language! Available: %lng2 $+  $chr(3) }
    else {
      hadd $cgsbsock transnick $gettok($mid($1,2,$len($1)),1,33)
      hadd $cgsbsock transchannel $3
      hadd $cgsbsock transword $5-
      var %txt = $replace($5-,$chr(44),%!2C,$chr(35),%!32,!,%!31,$chr(36),%!24,',%!27,$chr(40),%!28,$chr(41),%!29)
      translate $cgsbsock %txt
    }
    sockwrite -n $cgsbsock silence $+(+,$gettok($mid($1,2,$len($1)),1,33))
    .timer -o 1 2 sockwrite -n $cgsbsock silence $+(-,$gettok($mid($1,2,$len($1)),1,33))
  }
}
on *:sockopen:translate:{
  var %t = $gettok($hget(cgsb,$+($sockname,.colors)),1,32), %u = $gettok($hget(cgsb,$+($sockname,.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),urbannick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3) | return }
  var %get = $+(http://translate.google.com/translate_t?text=,$replace($gettok($sock($sockname).mark,3-,32),$chr(32),+),&sl=,$gettok($gettok($sock($sockname).mark,2,32),1,61),&tl=,$remove($gettok($gettok($sock($sockname).mark,2,32),2,61),>))
  sockwrite -n $sockname GET %get HTTP/1.1
  sockwrite -n $sockname Host: $+(www.google.com,$str($crlf, 2))
}
on *:sockread:translate:{
  var %t = $gettok($hget(cgsb,$+($sockname,.colors)),1,32), %u = $gettok($hget(cgsb,$+($sockname,.colors)),2,32)
  if ($sockerr > 0) { sockwrite -n $gettok($sock($sockname).mark,1,32) notice $hget($gettok($sock($sockname).mark,1,32),urbannick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Socket error(s). Try again later. $chr(3) | return }
  var %a
  :start
  sockread -f %a
  %a = $gettok(%a,$+($findtok(%a,id=result_box,1,32),-),32)
  %a = $mid(%a,1,900)
  tokenize 32 $remove(%a,$chr(35))
  var %txt = $+(<,$gettok($replace($gettok($1-,$+(1-,$findtok($1-,</div>,1,32)),32),</div>,</div>*),1,42))
  %txt = $striphtml(%txt)
  if (%txt) { %answer = %txt }
  if (%answer) { .timertranslate off | var %n = $iif($len(%answer) >= 850,$+($mid(%answer,1,850),...),%answer) | sockwrite -n $gettok($sock($sockname).mark,1,32) privmsg $hget($gettok($sock($sockname).mark,1,32),transchannel) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ translate: %n $chr(3) | unset %answer | unset %found | destroytranslate $gettok($sock($sockname).mark,1,32) | sockclose translate | return }
  if ($sockbr > 0) { goto start }
  .timertranslate -o 1 1 endtranslate $gettok($sock($sockname).mark,1,32)
}
alias -l endtranslate {
  var %t = $gettok($hget(cgsb,$+($sockname,.colors)),1,32), %u = $gettok($hget(cgsb,$+($sockname,.colors)),2,32)
  sockwrite -n $1 notice $hget($1,transnick) $+(:,$iif(%u || %t,$+($chr(3),%t,$chr(44),%u,$chr(32)))) $+ Nothing found. $chr(3)
  destroytranslate $1
}
